#! /usr/bin/perl -w

#################################################################################
#		EXPORT DE DONNEES ISSUES DE TBvirus
#		DANS UN FICHIER EXCEL		
#
#		Version 1.0 
#
#		Julien VEHENT - juillet 2006
#
#################################################################################
	
sub sub_excel() {

	# le passage de paramtres est fait avec des pointeurs pour rcuprer les tableaux manipuls dans le script tbvirus.pl;
	# une fois la rcup des paramtres effectues, ils se manipulents comme des tableaux tout  fait classiques.
	local($DEBUG,$fichier_sortie, *DonneesMail, *DonneesFichiers, *DonneesVirusMail, *TotauxMail, *Top5virmail, $totmailinf, *DonneesVirusFichiers,$tot_fichiers_inf, $NbMachinesUniqInf, $export_png) = @_;
	
	if($DEBUG==1){
		open(DEBUG_FILE,">>.\\logs\\debug_TBvir.txt") or die print "IMPOSSIBLE D'OUVRIR LE FICHIER DEBUG\n$!\n";
		print DEBUG_FILE "SUB_EXCEL ==> Gnration du rapport au format Excel\n";
	}


	########################################################################################
	#
	# Cration du fichier excel avec 3 feuilles
	#
	#
	my $Excel = Win32::OLE->new('Excel.Application', 'Quit');
	$Excel->{SheetsInNewWorkbook} = 3;
	my $fichier = $Excel->Workbooks->Add;

	# Pointeurs vers les feuilles
	my $feuille_mail = $fichier->Worksheets(1);
	$feuille_mail->{Name} = 'Stat. messagerie';

	my $feuille_fichiers = $fichier->Worksheets(2);
	$feuille_fichiers->{Name} = 'Stat. Norton';

	my $feuille_virus = $fichier->Worksheets(3);
	$feuille_virus->{Name} = 'Stat. virus';

	# variable outil pour effectuer des slections
	my $select;

	#########################################################################################
	#
	# STATISTIQUES DE LA MESSAGERIE
	#
	#
	
	# Selection de la zone d'entete
	$select = $feuille_mail->Range("A1:E1");
	# Cration des champs d'entete
	$select->{Value} = 
		[['Date','Mails_Entrants','Mails_Sortants','Webwasher','Antigen']];

	# ... en gras, c'est plus joli
	$select->Font->{Bold} = 1;

	# on slectionne les cases pour l'ajout des valeurs : 1ere case en haut a gauche et
	# derniere case en bas a droite
	$select = $feuille_mail->Range(sprintf "A2:E%d", 2+$#DonneesMail);
	#on met les valeurs dans les cases
	$select->{Value} = \@DonneesMail;

	# valeurs des totaux
	# (remis en forme avant copie)
	for my $i (1,3,5,7){
		# rcupre la ligne
		my $current = $TotauxMail[$i];
		# supprime le dize, si prsent
		$current =~ s/#//;
		# dcoupe sur les tabulation
		my @value = split(/\t\t/,$current);
		# supprime les tabs, s'il en reste
		$value[1] =~ s/\t+//g;
		# envoie la valeur dans le tableau
		push @totmail, $value[1];
	}
	# criture a la suite de la feuille
	$select = $feuille_mail->Range(sprintf "A%d", 4+$#DonneesMail);
	$select->{Value} = ['Totaux'];

	$select = $feuille_mail->Range(sprintf "B%d:E%d", 4+$#DonneesMail, 4+$#DonneesMail);
	$select->{Value} = \@totmail;

	$select = $feuille_mail->Range(sprintf "A%d:E%d", 4+$#DonneesMail, 4+$#DonneesMail);
	$select->Font->{Bold} = 1;

	#un peu de mise en page 
	$select = $feuille_mail->Range(sprintf "A1:E%d", 4+$#DonneesMail);
	$select->{HorizontalAlignment}=xlCenter;
	$select->{VerticalAlignment}=xlCenter;
	$select->Columns->{Autofit}=1;


	######
	# Cration de la courbe pour la messagerie
	
	# zone slectionne
	my $graph_mail = $fichier->Charts->Add;

	# type de graphique
	$graph_mail->{ChartType} = xlLineMarkers;

	# placement sur la feuille
	$graph_mail->Location(xlLocationAsObject, $feuille_mail->{Name});

	# correction d'un bug Excel
	$graph_mail = $Excel->ActiveChart;

	# slection de la source de donne
	$select = $feuille_mail->Range(sprintf "A1:E%d", 2+$#DonneesMail);
	# on considre les champs par colonnes (PlotBy)
	$graph_mail->SetSourceData({Source => $select, PlotBy =>xlColumns});
	
	#on lui donne un titre
	$graph_mail->{HasTitle} = 1;
	$graph_mail->ChartTitle->{Text} = "Messagerie MAAF";

	#export png
	if($export_png==1){
		$graph_mail_sortie = $fichier_sortie."-graph_messagerie.png";
		$graph_mail->Export({
				FileName=> $graph_mail_sortie,
				FilterName => 'PNG',
				Interactive =>0});
	}
											       #
											       #
											       #
						################################################
	
	#########################################################################################
	#
	# STATISTIQUES DES FICHIERS
	#
	#
	
	# Selection de la zone d'entete
	$select = $feuille_fichiers->Range("A1:F1");
	# Cration des champs d'entete
	$select->{Value} = 
		[['Date','Nb fichiers contamins','Total de postes infects','Nb Ordi en agence','Nb ordi au sige','Nb serveurs']];

	# ... en gras, c'est plus joli
	$select->Font->{Bold} = 1;

	# on slectionne les cases pour l'ajout des valeurs : 1ere case en haut a gauche et
	# derniere case en bas a droite
	$select = $feuille_fichiers->Range(sprintf "A2:F%d", 2+$#DonneesFichiers);
	#on met les valeurs dans les cases
	$select->{Value} = \@DonneesFichiers;

	# valeur des totaux
	$select = $feuille_fichiers->Range(sprintf "A%d:B%d", 4+$#DonneesFichiers, 4+$#DonneesFichiers);
	$select->{Value} = ['Fichiers inf.',"$tot_fichiers_inf"];
	$select->Font->{Bold} = 1;

	# valeur des totaux
	$select = $feuille_fichiers->Range(sprintf "A%d:B%d", 5+$#DonneesFichiers, 5+$#DonneesFichiers);
	$select->{Value} = ['Machines uniques',"$NbMachinesUniqInf"];
	$select->Font->{Bold} = 1;


	#un peu de mise en page 
	$select = $feuille_fichiers->Range(sprintf "A1:F%d", 5+$#DonneesFichiers);
	$select->{HorizontalAlignment}=xlCenter;
	$select->{VerticalAlignment}=xlCenter;
	$select->Columns->{Autofit}=1;


	######
	# Cration de la courbe des fichiers infects
	# (date et nb fichiers infects seulement)
	
	my $graph_fichiers = $fichier->Charts->Add;

	$graph_fichiers->{ChartType} = xlLineMarkers;

	$graph_fichiers->Location(xlLocationAsObject, $feuille_fichiers->{Name});

	$graph_fichiers = $Excel->ActiveChart;

	$select = $feuille_fichiers->Range(sprintf "A1:C%d", 2+$#DonneesFichiers);
	$graph_fichiers->SetSourceData({Source => $select, PlotBy =>xlColumns});
	
	#on lui donne un titre
	$graph_fichiers->{HasTitle} = 1;
	$graph_fichiers->ChartTitle->{Text} = "Infections des postes MAAF";

	#export png
	if($export_png==1){
		$graph_fichiers_sortie = $fichier_sortie."-graph_fichiers.png";
		$graph_fichiers->Export({
				FileName=> $graph_fichiers_sortie,
				FilterName => 'PNG',
				Interactive =>0});
	}

											       #
											       #
											       #
						################################################
	
	#########################################################################################
	#
	# STATISTIQUES DES VIRUS DE LA MESSAGERIE
	#
	#
	
	# Selection de la zone de tite
	$select = $feuille_virus->Range("A1");
	$select->{Value} = 
		[['Virus de la messagerie (Webwasher & Antigen)']];
	$select->Font->{Bold} = 1;

	# Selection de la zone d'entete
	$select = $feuille_virus->Range("A2:C2");
	$select->{Value} = 
		[['Nom','Nb Infections','Type de virus']];
	$select->Font->{Bold} = 1;

	# on slectionne les cases pour l'ajout des valeurs : 1ere case en haut a gauche et
	# derniere case en bas a droite
	$select = $feuille_virus->Range(sprintf "A3:C%d", 2+$#DonneesVirusMail);
	$select->{Value} = \@DonneesVirusMail;



	######
	# Cration du graphique
	
	my $graph_virmail = $fichier->Charts->Add;
	
	# type camembert
	$graph_virmail->{ChartType} = xl3DPie;

	# affichage du pourcentage du total de chaque portion
	$graph_virmail->ApplyDataLabels({Type => xlDataLabelsShowPercent, LegendKey => 0});

	$graph_virmail->Location(xlLocationAsObject, $feuille_virus->{Name});

	$graph_virmail = $Excel->ActiveChart;

	$select = $feuille_virus->Range(sprintf "A2:B%d", 2+$#DonneesVirusMail);
	$graph_virmail->SetSourceData({Source => $select, PlotBy =>xlColumns});
	
	$graph_virmail->{HasTitle} = 1;
	$graph_virmail->ChartTitle->{Text} = "Virus de la messagerie";

	#export png
	if($export_png==1){
		$graph_virmail_sortie = $fichier_sortie."-camembert_virus_messagerie.png";
		$graph_virmail->Export({
				FileName=> $graph_virmail_sortie,
				FilterName => 'PNG',
				Interactive =>0});
	}

	######
	# Meme chose pour le TOP 5 des virus de la messagerie
	$select = $feuille_virus->Range("E1");
	$select->{Value} = 
		[['Top 5 virus messagerie']];
	$select->Font->{Bold} = 1;

	$select = $feuille_virus->Range("E2:F2");
	$select->{Value} = [['Nom','Nb Infections']];
	$select->Font->{Bold} = 1;

	$select = $feuille_virus->Range("E3:F3");
	$select->{Value} = [['Total mails infects', "$totmailinf"]];

	$select = $feuille_virus->Range("E4:F8");
	$select->{Value} = \@Top5virmail;

	######
	# Cration du graphique
	
	my $graph_topmail = $fichier->Charts->Add;
	
	# type colonnes
	$graph_topmail->{ChartType} = xl3DColumn;

	# affichage de la valeur du total de chaque portion
	$graph_topmail->ApplyDataLabels({Type => xlDataLabelsShowValue, LegendKey => 0});

	$graph_topmail->Location(xlLocationAsObject, $feuille_virus->{Name});

	$graph_topmail = $Excel->ActiveChart;

	$select = $feuille_virus->Range("E2:F8");
	$graph_topmail->SetSourceData({Source => $select, PlotBy =>xlColumns});
	
	$graph_topmail->{HasTitle} = 1;
	$graph_topmail->ChartTitle->{Text} = "Top 5 des virus de la messagerie\n(toutes variantes confondues)";

	#export png
	if($export_png==1){
		$graph_topmail_sortie = $fichier_sortie."-graph_top5_virus_messagerie.png";
		$graph_topmail->Export({
				FileName=> $graph_topmail_sortie,
				FilterName => 'PNG',
				Interactive =>0});
	}
											       #
											       #
											       #
						################################################

	#########################################################################################
	#
	# STATISTIQUES DES VIRUS NORTON
	#
	#
	
	# Selection de la zone de tite
	$select = $feuille_virus->Range("H1");
	$select->{Value} = 
		[['Virus sur les fichiers (Norton)']];
	$select->Font->{Bold} = 1;

	# Selection de la zone d'entete
	$select = $feuille_virus->Range("H2:J2");
	$select->{Value} = 
		[['Nom','Nb Infections','Type de virus']];
	$select->Font->{Bold} = 1;

	# on slectionne les cases pour l'ajout des valeurs : 1ere case en haut a gauche et
	# derniere case en bas a droite
	$select = $feuille_virus->Range(sprintf "H3:J%d", 2+$#DonneesVirusFichiers);
	$select->{Value} = \@DonneesVirusFichiers;

	######
	# Cration du graphique
	
	my $graph_virfichiers = $fichier->Charts->Add;

	$graph_virfichiers->{ChartType} = xl3DPie;

	$graph_virfichiers->ApplyDataLabels({Type => xlDataLabelsShowPercent, LegendKey => 0});

	$graph_virfichiers->Location(xlLocationAsObject, $feuille_virus->{Name});

	$graph_virfichiers = $Excel->ActiveChart;

	$select = $feuille_virus->Range(sprintf "H2:I%d", 2+$#DonneesVirusFichiers);
	$graph_virfichiers->SetSourceData({Source => $select, PlotBy =>xlColumns});
	
	$graph_virfichiers->{HasTitle} = 1;
	$graph_virfichiers->ChartTitle->{Text} = "Virus sur les fichiers";

	#export png
	if($export_png==1){
		$graph_virfichiers_sortie = $fichier_sortie."-camembert_virus_Norton.png";
		$graph_virfichiers->Export({
				FileName=> $graph_virfichiers_sortie,
				FilterName => 'PNG',
				Interactive =>0});
	}

	######
	# Meme chose pour le TOP 5 des virus Norton
	$select = $feuille_virus->Range("L1");
	$select->{Value} = 
		[['Top 5 virus Norton']];
	$select->Font->{Bold} = 1;

	$select = $feuille_virus->Range("L2:M2");
	$select->{Value} = [['Nom','Nb Infections']];
	$select->Font->{Bold} = 1;

	$select = $feuille_virus->Range("L3:M3");
	$select->{Value} = [['Total fichiers infects', "$tot_fichiers_inf"]];

	$select = $feuille_virus->Range("L4:M8");
	$select->{Value} = $feuille_virus->Range("H3:I7")->{'Value'};
	my $graph_topfichiers = $fichier->Charts->Add;
	
	# type colonnes
	$graph_topfichiers->{ChartType} = xl3DColumn;

	# affichage de la valeur du total de chaque portion
	$graph_topfichiers->ApplyDataLabels({Type => xlDataLabelsShowValue, LegendKey => 0});

	$graph_topfichiers->Location(xlLocationAsObject, $feuille_virus->{Name});

	$graph_topfichiers = $Excel->ActiveChart;

	$select = $feuille_virus->Range("L2:M8");
	$graph_topfichiers->SetSourceData({Source => $select, PlotBy =>xlColumns});
	
	$graph_topfichiers->{HasTitle} = 1;
	$graph_topfichiers->ChartTitle->{Text} = "Top 5 des virus Norton";

	#export png
	if($export_png==1){
		$graph_topfichiers_sortie = $fichier_sortie."-graph_top5_virus_Norton.png";
		$graph_topfichiers->Export({
				FileName=> $graph_topfichiers_sortie,
				FilterName => 'PNG',
				Interactive =>0});
	}
												#
												#
							#########################################
	
	# mise en page de la 3eme feuille
	$select = $feuille_virus->Range(sprintf "A2:Z2000"); # ca c'est un peu bourrin...
	$select->{HorizontalAlignment}=xlCenter;
	$select->{VerticalAlignment}=xlCenter;
	$select->Columns->{Autofit}=1;


	$fichier->SaveAs("$fichier_sortie");
	$fichier->Close;

	if($DEBUG==1){
		print DEBUG_FILE "SUB_EXCEL ==> Fichier excel gnr avec succs\n";
		close DEBUG_FILE;
	}

}
