################################################################################
##
##	Script d'analyse des logs antigen
##
##
##	version 2
##
##
##	Excution : perl 
##	Christophe MOREAU / DIT/ PSQ / Scurit
##
##	r-criture : juin 2006 par J. VEHENT pour intgration dans TBvirus
##		* ajout des controles de dates
##		* optimisation du tps d'excution (sort, tests, parcours)
##		* optimisation de l'espace mmoire utilis
##		* ajout des fonctions debug
##		* intgration dans le front end "LogReport"
##	
################################################################################


#!/bin/perl


sub sub_antigen() {
	###########################################################
	# Rcupration du passage de paramtres
	#
	local($DEBUG,$debut_exploitation,$fin_exploitation) = @_;

	###########################################################
	# Ouverture des fichiers
	#
	my $rep_source = "\\\\XXXXXXXXXX\\secsi\\virus\\archivage\\Antigen\\";
	my $fichier_sortie = ".\\logs\\ANTIGEN_log_sortie.txt";
	my $fichier_date_tri = ".\\logs\\ANTIGEN_log_tri.txt";
	my $fichier_date = ".\\logs\\ANTIGEN_log_date.txt";
	my $DEBUG_FILE = ".\\logs\\debug_TBvir.txt";

	#listage des fichiers de repsource dans un tableau
	opendir(LOGANTIGEN,$rep_source) or die print "\nIMPOSSIBLE D'OUVRIR LE REPERTOIRE $rep_source\n$!\n";
	@lst_logs = readdir(LOGANTIGEN);
	close(LOGANTIGEN);

	open (FILE2, ">$fichier_sortie") or die "impossible d'ouvrir le fichier $fichier_sortie\n$!\n";

	if($DEBUG==1){
		open (DEBUG_ANTIGEN, ">>$DEBUG_FILE") or die "SUB_ANTIGEN ==> impossible d'ouvrir le fichier $DEBUG_FILE\n$!\n";
	}

	open (FILE3, ">$fichier_date_tri") or die "impossible d'ouvrir le fichier $fichier_date_tri";

	if($DEBUG==1){print DEBUG_ANTIGEN "SUB_ANTIGEN ==> exploitation de $debut_exploitation a $fin_exploitation\n";}

	#parcours des fichiers
	foreach $fichier (@lst_logs){

		#chaque rpertoire contient "." et ".." que l'on ne traite videmment pas
		#on controle galement les dates des fichiers
		unless(($fichier eq ".") or ($fichier eq "..")
			or substr($fichier,8,8) < $debut_exploitation
			or substr($fichier,8,8) > $fin_exploitation)
		{
		
			# on ouvre le fichier courant
			# ATTENTION : il faut spcifier le chemin ET le nom du fichier => $rep_source.$fichier
			open (LOGANTI, $rep_source.$fichier) or die "impossible d'ouvrir $fichier\n$!\n";

			print DEBUG_ANTIGEN "debug= $DEBUG\tdate debut= $debut_exploitation\tfin_exp= $fin_exploitation\n";

			if($DEBUG==1){print DEBUG_ANTIGEN "SUB_ANTIGEN ==> parcours du fichier $fichier\n";}	

			###########################################################
			# Nettoyage du fichier 
			#
			while(<LOGANTI>) {
				chomp;
		
				# on dcoupe la ligne sur le point virgule donc on obtient :
				# $ligne[0] la date de l'enregistrement
				# $ligne[1] le nom du virus
				my($datebrute,$virus) = split(/;/,$_);

				# remise en forme de la date au format AAAAMMJJ
				@date = split (/ /,$datebrute);
				my @date_formated = split(/\//, $date[0]);
				my $current_date_formated = $date_formated[2].$date_formated[1].$date_formated[0];

				# est-ce que la date trouve est dans la priode exploites ?
				unless (	$current_date_formated < $debut_exploitation
						or $current_date_formated > $fin_exploitation
				)
				{ #si on est dans les bonnes dates, on recherche la valeur du virus
				
					#on ne considre pas les 3 entres suivantes
					if ($virus !~ m/IFrame@expl/) {
						if ($virus !~ m/Exploit.IFrame.B/) {	
							if ($virus !~ m/Fragmented Message/) {	
						
								#Impression des rsultats
								print FILE2 "$date[2] $virus\n";
								if($DEBUG==1){																				print DEBUG_ANTIGEN "SUB_ANTIGEN ==> virus trouv : $virus\n";
								}
								print FILE3 "$date_formated[0]/$date_formated[1]/$date_formated[2]\n";
							}
						}
					}
				}
			}
		}
	}
	

	if($DEBUG==1){close FILE2;}
	close FILE3;


	###########################################################
	# Sommes par virus
	#
	# Une liste des "dates" de virus trouvs est stocke dans 
	# FILE1. On compte le nombre de fois qu'apparait chaque 
	# date et on stocke le rsultat dans $somme_virus

	my %somme_virus;
	open (FILE1, "$fichier_date_tri") or die "impossible d'ouvrir le $fichier_date_tri";
	while (<FILE1>) {
	    chomp;
	    my @ligne = split;

	    foreach $i (@ligne) {
		# ajoute 1 au nb d'occ du mot $i
		$somme_virus{$i}++;
	    }	
	}
	close (FILE1);
	unlink ("$fichier_date_tri");

	##################################################
	# enregistre le nombre d'occurence dans un fichier
	##################################################

	open (FILE3 , ">$fichier_date") or die "impossible d'ouvrir le $fichier3";
	# affiche tout le tableau associatif d'occ

	#classement du fichier par nb de virus dcroissant
	my @totaux = sort {
		 $somme_virus{$b} <=> $somme_virus{$a}
		 } keys %somme_virus;
	if($DEBUG==1){print DEBUG_ANTIGEN "SUB_ANTIGEN ==> tri de $#totaux lignes du tableau de mails infectes\n";}

	#affichage de chaque entre dans FILE3
	for ($l=0; $l<@totaux; $l++) {

		print FILE3 "$totaux[$l] : $somme_virus{$totaux[$l]} mails infectes.\n";
	}

	if($DEBUG==1){
		close DEBUG_ANTIGEN;
	}
	close (FILE3);
}
