#! /usr/bin/perl
################################################################################
##
##	Export automatique mensuel :
##
##		Ce script dfinit un ensemble de fonctions permettant a 
##		l'application TBvirus de gnrer un export automatique des
##		logs du mois prcdent dans un fichier annuel au format excel
##
##	Julien VEHENT - juillet 2006
##		
##
################################################################################


#####################
# rcupre la date du mois prcdent (celui a exploiter)
#
sub getdateexploit(){
		my @date = localtime;
		my $annee = $date[5]+1900;
		my $mois = $date[4];

		# $mois va de 0 a 11. si la valeur est 0 alors on doit
		# exploiter le mois de dcembre de l'anne prcdente.
		if ($mois==0){
			$mois=12;
			$annee -= 1;
		}

		# ici on s'assure que datexploit est toujours sur 6 chiffres
		if ($mois < 10){
			$dateexploit = $annee.'0'.$mois;
		}
		else { $dateexploit = $annee.$mois; }

		return $dateexploit;
}


#####################
# test si une exploitation a dj t faite pour un mois donn
#
sub test_dejafait(){
	# passage de paramtre : $retour est un pointeur vers une variable de la fonction appelante
	local($date,*retour) = @_;

	# MODIFICATION DU SIGNAL DIE
	#
	# ce code modifie l'excution d'un "die" en lui demandant d'crire dans les logs (si mode debug)
	# puis de passer la valeur retour a -1 (erreur d'excution) et enfin de mourrir (die classique)
	# =>tous les "die" de ce programme utiliseront le schma dcrit par le code ci-dessous
	local $SIG{'__DIE__'} = sub {	open(DEBUG_EXPORT,">>.\\logs\\DEBUG_Export_Auto_Mensuel.txt")or print "PLANTAGE COMPLET !!!! TUEZ L'APPLICATION\n";
					print DEBUG_EXPORT "TEST_DEJAFAIT ==> $_[0]\n";
					close DEBUG_EXPORT;
					$retour = -1;
					die $_[0];
				};
	
	my $annee = substr($date,0,4);
	my $mois = substr($date,4,2)+1;

	# transformation du mois
	%month = (2=>'janvier',3=>'fevrier',4=>'mars',5=>'avril',6=>'mai',7=>'juin',8=>'juillet',9=>'aout',10=>'septembre',11=>'octobre',12=>'novembre',13=>'decembre');

	my $chemin_fich = "\\\\M001700\\SECSI\\VIRUS\\Suivi_Virus_$annee\\Tableau_Bord_Virus_$annee.xls";

	# si le fichier existe
	if (-e $chemin_fich){

		# on l'ouvre
		my $Excel = Win32::OLE->new('Excel.Application', 'Quit');
		my $fichier = $Excel->Workbooks->Open($chemin_fich);
		# on se place sur la feuille du mois traits
		my $feuille = $fichier->Worksheets($mois);

		open(DEBUG_EXPORT,">>.\\logs\\DEBUG_Export_Auto_Mensuel.txt")or print "PLANTAGE COMPLET !!!! TUEZ L'APPLICATION\n";
		print DEBUG_EXPORT "TEST_DEJAFAIT ==> accs en cours aux cellules de la feuille n $mois pour le mois de $month{$mois}\n";
		close DEBUG_EXPORT;

		# et on rcupre le contenu des cellules (normalement elles sont vides)
		my $cellules = $feuille->Range("B4:E7")->{'Value'};
		$fichier->Close;

		# si elles ne sont pas vides, on retourne une erreur
		foreach my $ref_cellules (@$cellules){
			foreach my $valeur (@$ref_cellules){
				if ($valeur ne "0"){
					eval{die "L'exploitation pour ce mois  dj t faite\n"};
				}
			}
		}
	}
}

#####################
# vrifie que tous les logs requis pour exploiter le mois sont prsents
#
sub test_presencelogs(){
	local($date,*retour)=@_;
	my $list_manquant = "";

	local $SIG{'__DIE__'} = sub {	open(DEBUG_EXPORT,">>.\\logs\\DEBUG_Export_Auto_Mensuel.txt")or print "PLANTAGE COMPLET !!!! TUEZ L'APPLICATION\n";
					print DEBUG_EXPORT "TEST_PRESENCELOGS ==> $_[0]\n";
					close DEBUG_EXPORT;
					$retour = -1;
				};

	# calendrier
	my %cal;
	# 		test anne bisextile
	my $annee = substr($date,0,4);
	if (0 == ($annee % 4) ) {
		# jour par mois dans l'anne bisextile
		%cal = ("01"=>31, "02"=>29, "03"=>31, "04"=>30, "05"=>31, "06"=>30, "07"=>31, "08"=>31, "09"=>30, "10"=>31, "11"=>30, "12"=>31);
	}
	else {
		# jour par mois dans l'anne normale
		%cal = ("01"=>31, "02"=>28, "03"=>31, "04"=>30, "05"=>31, "06"=>30, "07"=>31, "08"=>31, "09"=>30, "10"=>31, "11"=>30, "12"=>31);
	}

	my $an_mois = substr($date,2,4);
	my $mois = substr($date,4,2);

	#####
	# test WebWasher pour tous les jours du mois (donc du fichier dat du 2 jusqu' la fin du mois)
	
	# rcup la liste des fichiers du rpertoire
	opendir(DIRWW,"\\\\M001700\\SECSI\\VIRUS\\Archivage\\Webwasher\\");
	@FICHWW = readdir DIRWW;
	close DIRWW;

	# parcours tous les jours du mois
	for my $jour (2..$cal{$mois}){
		
		my $present=0;

		# pour chaque jour, stocke le dbut du nom du fichier attendu
		if($jour<10){
			$log_WW = "foundviruses".$an_mois."0".$jour;
		}
		else {
			$log_WW = "foundviruses".$an_mois.$jour;
		}

		# vrifie que le fichier existe dans la liste
		foreach $fichier (@FICHWW){
			if ($fichier =~/$log_WW.*-192\.168\.237\.3\.log/){	# cette regexp permet de tester ma prsence d'un log
				$present=1;					# sans connaitre l'heure de gnration
			}							# =>format log WW = foundvirusesAAMMJJhhmm-192.168.237.3.log
		}
	
		# si a la fin du parcours de la liste, le fichier n'a pas t trouv, 
		# on stocke son nom dans la liste des fichiers manquants
		if($present==0){
			$list_manquant = $list_manquant."WEBWASHER => $log_WW\n";
			eval{die "Fichier $log_WW non trouv"};
		}
		
	}
	#hors de la boucle on test les dernier fichier, dat du 1er jour du mois suivant	
	#ou du premier jour de l'anne suivante si on exploite le mois de dcembre
	if ($mois == 12){
		$annee++;
		$an_mois = substr($annee,2,4)."01";
	}
	else{
		$an_mois++;
	}
	$log_WW = "foundviruses".$an_mois."01";

	my $present=0;
	foreach $fichier (@FICHWW){
		if ($fichier =~/$log_WW.*-192\.168\.237\.3\.log/){
			$present=1;
		}
	}
	if($present==0){
		$list_manquant = $list_manquant."WEBWASHER => $log_WW\n";
		eval{die "Fichier $log_WW non trouv"};
	}

	#####
	# test Antigen pour tous les jours du mois (du 1 au dernier jour)
	for my $jour (1..$cal{$mois}){
		
		if ($jour<10){
			$log_antigen = "\\\\M001700\\SECSI\\VIRUS\\Archivage\\Antigen\\antigen-".$date."0".$jour.".txt";
		}
		else{
			$log_antigen = "\\\\M001700\\SECSI\\VIRUS\\Archivage\\Antigen\\antigen-".$date.$jour.".txt";
		}

		unless(-e $log_antigen){
			$list_manquant = $list_manquant."ANTIGEN => $log_antigen\n";
			eval{die "Fichier $log_antigen non trouv"};
		}
		
	}


	#####
	# test Report pour le fichier du mois, on regarde qu'on a bien toutes les lignes
	my %months = ("01"=>"Jan", "02"=>"Feb", "03"=>"Mar", "04"=>"Apr", "05"=>"May", "06"=>"Jun", "07"=>"Jul", "08"=>"Aug", "09"=>"Sep", "10"=>"Oct", "11"=>"Nov", "12"=>"Dec");
	my $report = "\\\\M001700\\SECSI\\VIRUS\\Archivage\\Report\\report_mail_".$months{$mois}.$annee.".txt";

	if (-e $report){
		for $jour (1..$cal{$mois}){
		
			my $ok=0;

			#le fichier est parcouru, on vrifie que toutes les lignes sont prsentes
			open(REPORT,$report) or die "IMPOSSIBLE D'OUVRIR $report";
		
			while(<REPORT>){
				# si la ligne pour une date donnee existe
				if ($jour<10){
					if( $_ =~/0$jour\/$months{$mois}\/$annee/){
						$ok = 1;
					}
				}
				else{
					if( $_ =~/$jour\/$months{$mois}\/$annee/){
						$ok = 1;
					}
				}
			}
			close REPORT;
		
			# si une ligne n'est pas prsente on l'ajoute dans la liste
			if($ok==0){
				$list_manquant = $list_manquant."REPORT => Pas d'entre pour le $jour\/$months{$mois}\/$annee\n";
			}
		}					
	}
	else { $list_manquant = $list_manquant."$report\n"; }

	######
	# test Norton / SAV Reporter : on regarde juste si la date le fichier le plus rcent couvre la priode a exploiter
	my $savdir = "\\\\M001700\\SECSI\\VIRUS\\Archivage\\Norton";
	opendir(SAVDIR,$savdir) or die "IMPOSSIBLE D'OUVRIR LE REPERTOIRE $savdir";
	my @savfiles = readdir(SAVDIR);
	close SAVDIR;

	my $lastdate=0;

	foreach $file (@savfiles){
		# on rcup la date du fichier le plus rcent
		if ( $lastdate < substr($file,23,8) ){
				$lastdate=substr($file,23,8);
		}
	}

	# on rutilise le calendrier des jours par mois pour voir si $lastdate correspond, au moins, au dernier
	# jour du mois a exploiter
	my $dernierjourmois = $date.$cal{$mois};

	if ($lastdate < $dernierjourmois){
		$list_manquant = $list_manquant."NORTON => Priode manquante du $lastdate au $dernierjourmois\n"
	}


	return $list_manquant;
}

#####################
# Cre le tableau de bord en dbut d'anne
#
sub new_TB(){
	
	local($date,*retour)=@_;
	$retour=-1;
	my $annee = substr($date,0,4);

	#crer le rpertoire
	my $rep = "\\\\M001700\\SECSI\\VIRUS\\Suivi_Virus_".$annee;
	mkdir $rep;

	# fichier de sortie
	my $fichier_sortie = $rep."\\Tableau_Bord_Virus_".$annee.".xls";

	#####
	# Cration du fichier excel avec 13 feuilles
	my $Excel = Win32::OLE->new('Excel.Application', 'Quit');
	$Excel->{SheetsInNewWorkbook} = 13;
	my $fichier = $Excel->Workbooks->Add;

	# Table de hachage contenant les feuilles
	my %F;

	# Pointeurs vers les feuilles
	my $F_synthese = $fichier->Worksheets(1);
	$F_synthese->{Name} = 'Synthse';
	$F{synthese} = $F_synthese;

	my $F_janvier = $fichier->Worksheets(2);
	$F_janvier->{Name} = 'Janvier';
	$F{janvier}=$F_janvier;

	my $F_fevrier = $fichier->Worksheets(3);
	$F_fevrier->{Name} = 'Fvrier';
	$F{fevrier}= $F_fevrier;

	my $F_mars = $fichier->Worksheets(4);
	$F_mars->{Name} = 'Mars';
	$F{mars}= $F_mars;

	my $F_avril = $fichier->Worksheets(5);
	$F_avril->{Name} = 'Avril';
	$F{avril}= $F_avril;

	my $F_mai = $fichier->Worksheets(6);
	$F_mai->{Name} = 'Mai';
	$F{mai}= $F_mai;

	my $F_juin = $fichier->Worksheets(7);
	$F_juin->{Name} = 'Juin';
	$F{juin}= $F_juin;

	my $F_juillet = $fichier->Worksheets(8);
	$F_juillet->{Name} = 'Juillet';
	$F{juillet}= $F_juillet;

	my $F_aout = $fichier->Worksheets(9);
	$F_aout->{Name} = 'Aot';
	$F{aout}= $F_aout;

	my $F_septembre = $fichier->Worksheets(10);
	$F_septembre->{Name} = 'Septembre';
	$F{septembre}= $F_septembre;

	my $F_octobre = $fichier->Worksheets(11);
	$F_octobre->{Name} = 'Octobre';
	$F{octobre}= $F_octobre;

	my $F_novembre = $fichier->Worksheets(12);
	$F_novembre->{Name} = 'Novembre';
	$F{novembre}= $F_novembre;

	my $F_decembre = $fichier->Worksheets(13);
	$F_decembre->{Name} = 'Dcembre';
	$F{decembre}= $F_decembre;

	# variable outil pour effectuer des slections
	my $select;

	#####
	# initialisation des feuilles (parcours de la table de hachage contenant les feuilles)

	#calendrier des jours par mois
	my %cal = ("janvier"=>31, "fevrier"=>28, "mars"=>31, "avril"=>30, "mai"=>31, "juin"=>30, "juillet"=>31, "aout"=>31, "septembre"=>30, "octobre"=>31, "novembre"=>30, "decembre"=>31);
	#petit modif de fevrier dans le cas d'une annee bisextile
	if (0 == ($annee % 4) ) { $cal{fevrier}=29;}

	# parcours de chacune des feuilles pour initialiser les cases
	foreach $mois (keys %F){

		# un titre general
		if ($mois eq "synthese"){
			$select = $F{$mois}->Range("F1");
			my $entete = "<======= SYNTHESE POUR L'ANNEE ".$annee." =======>";
			$select->{Value} = ["$entete"];
			$select->Font->{Bold} = 1;
			$select->Font->{Size} = 14;
		}
		else {
			$select = $F{$mois}->Range("F1");
			my $entete = "<======= RESULTAT POUR LE MOIS DE ".$mois." ".$annee." =======>";
			$select->{Value} = ["$entete"];
			$select->Font->{Bold} = 1;
		}

		# un titre pour chaque section
		$select = $F{$mois}->Range("A2:Y2");
		$select->{Value}=[['','Rsultats de la messagerie','','','','','','','Rsultats des fichiers','','','','','Virus de la messagerie','','','Top 5 messagerie','','','Virus des fichiers','','','','Top 5 fichiers','']];
		$select->Font->{Bold} = 1;
		
		# les champs de chaque section
		$select = $F{$mois}->Range("A3:Y3");
		$select->{Value}=[['Date','Entrants','Sortants','WebWasher','Antigen','','Date','Fichiers inf','Postes inf','Ordi agence','Ordi siege','Serveur','','Nom','Nb inf','','Nom','Nb inf','','Nom','Nb inf','Type','','Nom','Nb inf']];
		$select->Font->{Bold} = 1;
		$select->Font->{Italic} = 1;

		# un peu de mise en page
		$select = $F{$mois}->Range(sprintf "A1:Z1000"); # ca c'est un peu bourrin...
		$select->{HorizontalAlignment}=xlCenter;
		$select->{VerticalAlignment}=xlCenter;

		# met a 0 les champs
		for $i (4..$cal{$mois}+3){
			for $j ('B','C','D','E','H','I','J','K','L'){
				$select = $F{$mois}->range(sprintf "$j$i");$select->{Value} = [0];
			}
		}
		for $i (4..9){
			for $j ('R','Y'){
				$select = $F{$mois}->range(sprintf "$j$i");$select->{Value} = [0];
			}
			for $j ('Q','X'){
				$select = $F{$mois}->range(sprintf "$j$i");$select->{Value} = ["a"];
			}
		}

		# on ne remplit pas la feuille synthese comme les autres
		if ($mois ne "synthese"){

			#remplit les colonnes de dates pour tous les mois
			for $jour (1..$cal{$mois}){
				$select = $F{$mois}->Range(sprintf "A%d",3+$jour);
				$mois_o = $mois;
				if($mois eq "fevrier"){$mois_o = "fvrier";}
				if($mois eq "aout"){$mois_o = "aot";}
				if($mois eq "decembre"){$mois_o = "dcembre";}
				my $datecase = $jour." ".$mois_o." ".$annee;
				$select->{Value}=["$datecase"];
			}
			for $jour (1..$cal{$mois}){
				$select = $F{$mois}->Range(sprintf "G%d",3+$jour);
				$mois_o = $mois;
				if($mois eq "fevrier"){$mois_o = "fvrier";}
				if($mois eq "aout"){$mois_o = "aot";}
				if($mois eq "decembre"){$mois_o = "dcembre";}
				my $datecase = $jour." ".$mois_o." ".$annee;
				$select->{Value}=["$datecase"];
			}
		}

	}

	#remplit les colonnes de date pour la feuille de synthse
	my $casedeb = 4;
	my $i=2;
	for $month ('janvier','fevrier','mars','avril','mai','juin','juillet','aout','septembre','octobre','novembre','decembre'){

				$select = $F{synthese}->Range(sprintf "A%d:A%d",$casedeb,4+$cal{$month}+$casedeb);
				my $feuille = $fichier->Worksheets($i);
				$select->{Value} = $feuille->Range(sprintf "A4:A%d", 4+$cal{$month})->{Value};
				$casedeb+=$cal{$month};
				$i++;
	}
	$select = $F_synthese->Range(sprintf "G4:G%d",$casedeb);
	$select->{Value} = $F_synthese->Range(sprintf "A4:A%d",$casedeb)->{Value};


	#####
	# generation des graphiques
	foreach $mois (keys %F){

		# messagerie
		my $graph_mail = $fichier->Charts->Add;
		$graph_mail->{ChartType} = xlLineMarkers;
		$graph_mail->ApplyDataLabels({Type => xlDataLabelsShowValue, LegendKey => 0});
		$graph_mail->Location(xlLocationAsObject, $F{$mois}->{Name});
		$graph_mail = $Excel->ActiveChart;

		if ($mois eq "synthese"){
			$select = $F{$mois}->Range(sprintf "A3:E%d", $casedeb-1);		# si la feuille est synthese on selectionne 
		}									# un colonne beaucoup plus longue que 
		else {									# dans le cas d'un mois classique
			$select = $F{$mois}->Range(sprintf "A3:E%d", 3+$cal{$mois});	# Donc, on a 2 types de select
		}
		$graph_mail->SetSourceData({Source => $select, PlotBy =>xlColumns});
		$graph_mail->{HasTitle} = 1;
		if ($mois eq "synthese"){
			$graph_mail->ChartTitle->{Text} = "Messagerie pour l'anne $annee";	# meme principe ici...
		}
		else {
			$graph_mail->ChartTitle->{Text} = "Messagerie pour $mois $annee";
		}

		# fichiers
		my $graph_fichiers = $fichier->Charts->Add;
		$graph_fichiers->{ChartType} = xlLineMarkers;
		$graph_fichiers->Location(xlLocationAsObject, $F{$mois}->{Name});
		$graph_fichiers = $Excel->ActiveChart;

		if ($mois eq "synthese"){
			$select = $F{$mois}->Range(sprintf "G3:I%d", $casedeb-1);
		}
		else {
			$select = $F{$mois}->Range(sprintf "G3:I%d", 3+$cal{$mois});
		}
		$graph_fichiers->SetSourceData({Source => $select, PlotBy =>xlColumns});
		$graph_fichiers->{HasTitle} = 1;
		if ($mois eq "synthese"){
			$graph_fichiers->ChartTitle->{Text} = "Infections des postes MAAF en $annee";
		}
		else {
			$graph_fichiers->ChartTitle->{Text} = "Infections des postes MAAF en $mois $annee";
		}


		# top 5 messagerie
		my $graph_topmail = $fichier->Charts->Add;
		$graph_topmail->{ChartType} = xl3DColumn;
		$graph_topmail->ApplyDataLabels({Type => xlDataLabelsShowValue, LegendKey => 0});
		$graph_topmail->Location(xlLocationAsObject, $F{$mois}->{Name});
		$graph_topmail = $Excel->ActiveChart;
		$select = $F{$mois}->Range("Q3:R9");
		$graph_topmail->SetSourceData({Source => $select, PlotBy =>xlColumns});
		$graph_topmail->{HasTitle} = 1;
		if ($mois eq "synthese"){
			$graph_topmail->ChartTitle->{Text} = "Synthse $annee\n\nTop 5 des virus de la messagerie\n(toutes variantes confondues)";
		}
		else {
			$graph_topmail->ChartTitle->{Text} = "$mois $annee\n\nTop 5 des virus de la messagerie\n(toutes variantes confondues)";
		}


		# top 5 fichiers
		my $graph_topfichiers = $fichier->Charts->Add;
		$graph_topfichiers->{ChartType} = xl3DColumn;
		$graph_topfichiers->ApplyDataLabels({Type => xlDataLabelsShowValue, LegendKey => 0});
		$graph_topfichiers->Location(xlLocationAsObject, $F{$mois}->{Name});
		$graph_topfichiers = $Excel->ActiveChart;
		$select = $F{$mois}->Range("X3:Y9");
		$graph_topfichiers->SetSourceData({Source => $select, PlotBy =>xlColumns});
		$graph_topfichiers->{HasTitle} = 1;
		if ($mois eq "synthese"){
			$graph_topfichiers->ChartTitle->{Text} = "Synthse $annee\n\nTop 5 des virus Norton\n";
		}
		else {
			$graph_topfichiers->ChartTitle->{Text} = "$mois $annee\n\nTop 5 des virus Norton\n";
		}

	}

	# enregistre et ferme
	$fichier->SaveAs("$fichier_sortie");
	$fichier->Close;

	$retour = 0;
}

#####################
# Stocke les informations mensuelles dans le tableau de bord annuel
#
sub sub_stocktb(){
	local($date,$fichtemp,*retour)=@_;
	$retour=-1;

	# transformation de la date
	my $mois = substr($date,4,2);
	my $annee = substr($date,0,4);

	# ouverture du fichier debug
	open(DEBUG_EXPORT,">>.\\logs\\DEBUG_Export_Auto_Mensuel.txt")or die "Impossible d'ouvrir le fichier DEBUG !\n$!";

	# chemin vers le tableau de bord
	my $TB = "\\\\M001700\\SECSI\\VIRUS\\Suivi_Virus_".$annee."\\Tableau_Bord_Virus_".$annee.".xls";

	# variables outils pour effectuer des slections
	my $select,$selectTB;

	# ouverture du tableau de bord
	my $Excel = Win32::OLE->new('Excel.Application', 'Quit');
	my $fichierTB = $Excel->WorkBooks->Open($TB);
	my $numfeuille = $mois+1;
	my $feuilleTB = $fichierTB->Worksheets($numfeuille);

	# ouverture du fichier temp
	my $fichiertemp = $Excel->WorkBooks->Open($fichtemp);
	my $feuilletemp = $fichiertemp->Worksheets(1);



	# recherche de la cellule de fin pour la messagerie
	my $casefin=2;
	my $blank = $feuilletemp->Range(sprintf "B%d",$casefin)->{'Value'}; # $blank est une variable gnrique pour contenir la valeur d'une cellule
	print DEBUG_EXPORT "SUB_STOCKTB ==> Recherche de case vide : valeur de B$casefin = $blank\n";

	while ($blank ne ""){
		$casefin++;
		$blank = $feuilletemp->Range(sprintf "B%d",$casefin)->{'Value'};
		print DEBUG_EXPORT "SUB_STOCKTB ==> Recherche de case vide : valeur de B$casefin = $blank\n";
	}
	# copie dans le tableau de bord
	$selectTB = $feuilleTB->Range(sprintf "B4:E%d",$casefin+2);
	$selectTB->{Value} = $feuilletemp->Range(sprintf "B2:E%d",$casefin)->{'Value'};
	# on rcup la ligne des totaux
	$select = $feuilleTB->Range(sprintf "A%d:E%d",$casefin+2,$casefin+2);
	$select->{Value} = $feuilletemp->Range(sprintf "A%d:E%d",$casefin+1,$casefin+1)->{'Value'};
	$select->Font->{Bold} = 1;



	# pour norton, on parcours les cases des deux fichiers pour mettre les lignes du fichier temp aux bonnes
	# dates du fichier TB (dans le fichier temp il n'y a de ligne que lorsque qu'un virus est trouv, dans le
	# fichier TB il y a une ligne par jour)
	$feuilletemp = $fichiertemp->Worksheets(2);
	$casefin=2; my $caseTB = 4;
	
	# $blank contient la valeur de la ligne de feuilletemp
	$blank = $feuilletemp->Range(sprintf "B%d",$casefin)->{'Text'};
	# on parcours le fichier temporaire jusqu' la fin
	while ($blank ne ""){

		# si la date du fichier temp ne correspond pas a la date de TB, on passe a la case
		# suivante de TB (on suppose que toutes les entres sont classes chronologiquement)
		my $datetemp = $feuilletemp->Range(sprintf "A%d",$casefin)->{'Text'};
		print DEBUG_EXPORT "SUB_STOCKTB ==> feuille temp : valeur de A$casefin = $datetemp\n";

		my $dateTB = $feuilleTB->Range(sprintf "G%d",$caseTB)->{'Text'};
		print DEBUG_EXPORT "SUB_STOCKTB ==> feuille TB : valeur de A$caseTB = $dateTB\n";

		# on ne garde que le jour
		$datetemp = substr($datetemp,0,2);
		$dateTB = substr($dateTB,0,2);

		while ("$datetemp" ne "$dateTB"){
			$caseTB++;
			$dateTB = $feuilleTB->Range(sprintf "G%d",$caseTB)->{'Text'};
			$dateTB = substr($dateTB,0,2);
		}

		# une fois qu'on est sur la bonne ligne, on cris la ligne de $feuilletemp dans la ligne de $feuilleTB
		$select = $feuilleTB->Range(sprintf "H%d:L%d",$caseTB,$caseTB);
		$select->{Value} = $feuilletemp->Range(sprintf "B%d:F%d",$casefin,$casefin)->{'Value'};

		# on met dans $blank la valeur de la ligne suivante de feuilletemp
		$casefin++;
		$blank = $feuilletemp->Range(sprintf "B%d",$casefin)->{'Text'};
	}
	# il reste a copier les totaux. on cherche la premiere ligne vide du tableau de bord
	$blank = $feuilleTB->Range(sprintf "G%d",$casefin)->{'Text'};
	while($blank ne ""){
		$caseTB++;
		$blank = $feuilleTB->Range(sprintf "G%d",$caseTB)->{'Text'};
	}
	# on selectionne la zone
	$select = $feuilleTB->Range(sprintf "G%d:H%d",$caseTB,$caseTB+1);
	# et on copie le contenu rcupr dans la fichier temporaire
	$select->{Value} = $feuilletemp->Range(sprintf "A%d:B%d",$casefin+1,$casefin+2)->{'Value'};
	$select->Font->{Bold} = 1;





	# copie des virus de la messagerie. on parcours feuilletemp jusqu'a ce que la ligne soit vide
	# et on copie chaque ligne dans feuilleTB
	$feuilletemp = $fichiertemp->Worksheets(3);
	$casefin=3; $caseTB = 4;
	$blank = $feuilletemp->Range(sprintf "A%d",$casefin)->{'Text'};
	while ($blank ne ""){
		$select = $feuilleTB->Range(sprintf "N%d:O%d",$caseTB,$caseTB);
		$select->{Value} = $feuilletemp->Range(sprintf "A%d:B%d",$casefin,$casefin)->{'Value'};
		$casefin++;$caseTB++;
		$blank = $feuilletemp->Range(sprintf "A%d",$casefin)->{'Text'};
		print DEBUG_EXPORT "SUB_STOCKTB ==> feuille TEMP : valeur de A$casefin = $blank\n";

	}
	



	# idem avec top 5 virus messagerie
	$casefin=3; $caseTB = 4;
	$blank = $feuilletemp->Range(sprintf "E%d",$casefin)->{'Text'};
	while ($blank ne ""){
		$select = $feuilleTB->Range(sprintf "Q%d:R%d",$caseTB,$caseTB);
		$select->{Value} = $feuilletemp->Range(sprintf "E%d:F%d",$casefin,$casefin)->{'Value'};
		$casefin++;$caseTB++;
		$blank = $feuilletemp->Range(sprintf "E%d",$casefin)->{'Text'};
		print DEBUG_EXPORT "SUB_STOCKTB ==> feuille TEMP : valeur de E$caseTB = $blank\n";

	}



	# idem avec virus fichiers
	$casefin=3; $caseTB = 4;
	$blank = $feuilletemp->Range(sprintf "H%d",$casefin)->{'Text'};
	while ($blank ne ""){
		$select = $feuilleTB->Range(sprintf "T%d:V%d",$caseTB,$caseTB);
		$select->{Value} = $feuilletemp->Range(sprintf "H%d:J%d",$casefin,$casefin)->{'Value'};
		$casefin++;$caseTB++;
		$blank = $feuilletemp->Range(sprintf "H%d",$casefin)->{'Text'};
		print DEBUG_EXPORT "SUB_STOCKTB ==> feuille TEMP : valeur de H$caseTB = $blank\n";

	}



	# idem avec top 5 virus fichiers
	$casefin=3; $caseTB = 4;
	$blank = $feuilletemp->Range(sprintf "L%d",$casefin)->{'Text'};
	while ($blank ne ""){
		$select = $feuilleTB->Range(sprintf "X%d:Y%d",$caseTB,$caseTB);
		$select->{Value} = $feuilletemp->Range(sprintf "L%d:M%d",$casefin,$casefin)->{'Value'};
		$casefin++;$caseTB++;
		$blank = $feuilletemp->Range(sprintf "L%d",$casefin)->{'Text'};
		print DEBUG_EXPORT "SUB_STOCKTB ==> feuille TEMP : valeur de L$caseTB = $blank\n";

	}
	
	$fichiertemp->Close;




	######
	# remplissage de la feuille de synthse
	
	# copie des rsultats messagerie et fichiers a la suite de ceux existants
	my $F_S = $fichierTB->Worksheets(1);
	$caseTB = 3;
	$blank = $F_S->Range(sprintf "B%d",$caseTB)->{'Text'};

	# on avance jusqu' trouver la premiere case vide de la colonne B dans la synthse
	while ($blank ne ""){ 
		$caseTB++;	
		$blank = $F_S->Range(sprintf "B%d",$caseTB)->{'Text'};
	}
	print DEBUG_EXPORT "SUB_STOCKTB ==> feuille Synthse : case vide trouve a B$caseTB\n";

	# pareil pour la feuille du mois
	my $casemois = 3;
	$blank = $feuilleTB->Range(sprintf "B%d",$casemois)->{'Text'};
	while ($blank ne ""){	
		$casemois++;
		$blank = $feuilleTB->Range(sprintf "B%d",$casemois)->{'Text'};
	}
	print DEBUG_EXPORT "SUB_STOCKTB ==> feuille du mois : case vide trouve a B$casemois\n";


	# on selectionne la zone de la synthse de la messagerie pour les valeurs du mois
	$select = $F_S->Range(sprintf "B%d:E%d",$caseTB, $caseTB+$casemois-6);
	print DEBUG_EXPORT "SUB_STOCKTB ==> Selection de la zone B$caseTB a E", $caseTB+$casemois-6,"\n";
	$select->{Value} = $feuilleTB->Range(sprintf "B4:E%d",$casemois-2)->{Value};
	print DEBUG_EXPORT "SUB_STOCKTB ==> Ecriture des informations pris dans la section B4 a E", $casemois-2,"\n";


	# copie des donnes sur les fichiers
	$select = $F_S->Range(sprintf "H%d:L%d",$caseTB, $caseTB+$casemois-6);
	$select->{Value} = $feuilleTB->Range(sprintf "H4:L%d",$casemois-2)->{Value};

	
	# copie des donnes sur les virus... c'est un peu particulier parce qu'on vrifie que
	# le virus n'est pas dj prsent dans la liste. Si c'est le cas, on ajoute la nouvelle valeur
	# a l'ancienne
	$casemois=4;
	my $virus = $feuilleTB->Range(sprintf "N%d",$casemois)->{'Text'};
	print DEBUG_EXPORT "SUB_STOCKTB ==> ajout du virus $virus dans la liste de la synthse\n";

	# parcours l'ensemble des virus de la feuille mensuelle
	while ($virus ne ""){
		
		# parcours l'ensemble des virus de la synthese
		$caseTB=3;
		$blankTB = $F_S->Range(sprintf "N%d",$caseTB)->{'Text'};
		my $existe=0;		
		while ($blankTB ne ""){

			# si le virus est dj prsent dans la liste de la synthese
			if($virus eq $blankTB){
				
				# on ajoute sa valeur 
				my $valvirus = $F_S->Range(sprintf "O%d",$caseTB)->{Value};
				$valvirus += $feuilleTB->Range(sprintf "O%d",$casemois)->{Value};
				$select = $F_S->Range(sprintf "O%d",$caseTB);
				$select->{Value} = $valvirus;

				# et on sors de la boucle
				$existe = 1;
			}
			# passage a la case suivante
			$caseTB++;
			$blankTB = $F_S->Range(sprintf "N%d",$caseTB)->{'Text'};
		}
		# si le virus n'tait pas dj prsent dans la liste
		if ($existe == 0){
			# on l'ajoute a la fin
			$select = $F_S->Range(sprintf "N%d:O%d",$caseTB,$caseTB);
			$select->{Value} = $feuilleTB->Range(sprintf "N%d:O%d",$casemois,$casemois)->{Value};
		}

		# passage au virus suivant
		$casemois++;
		$virus = $feuilleTB->Range(sprintf "N%d",$casemois)->{'Text'};
		print DEBUG_EXPORT "SUB_STOCKTB ==> ajout du virus $virus dans la liste de la synthse\n";

	}
	
	# EXACTEMENT la meme chose mais avec les virus des fichiers
	$casemois=4;
	my $virus = $feuilleTB->Range(sprintf "T%d",$casemois)->{'Text'};
	print DEBUG_EXPORT "SUB_STOCKTB ==> ajout du virus $virus dans la liste de la synthse\n";

	# parcours l'ensemble des virus de la feuille mensuelle
	while ($virus ne ""){
		
		# parcours l'ensemble des virus de la synthese
		$caseTB=3;
		$blankTB = $F_S->Range(sprintf "T%d",$caseTB)->{'Text'};
		my $existe=0;		
		while ($blankTB ne ""){

			# si le virus est dj prsent dans la liste de la synthese
			if($virus eq $blankTB){
				
				# on ajoute sa valeur 
				my $valvirus = $F_S->Range(sprintf "U%d",$caseTB)->{Value};
				$valvirus += $feuilleTB->Range(sprintf "U%d",$casemois)->{Value};
				$select = $F_S->Range(sprintf "U%d",$caseTB);
				$select->{Value} = $valvirus;

				# et on sors de la boucle
				$existe = 1;
			}
			# passage a la case suivante
			$caseTB++;
			$blankTB = $F_S->Range(sprintf "T%d",$caseTB)->{'Text'};
		}
		# si le virus n'tait pas dj prsent dans la liste
		if ($existe == 0){
			# on l'ajoute a la fin
			$select = $F_S->Range(sprintf "T%d:V%d",$caseTB,$caseTB);
			$select->{Value} = $feuilleTB->Range(sprintf "T%d:V%d",$casemois,$casemois)->{Value};
		}

		# passage au virus suivant
		$casemois++;
		$virus = $feuilleTB->Range(sprintf "T%d",$casemois)->{'Text'};
		print DEBUG_EXPORT "SUB_STOCKTB ==> ajout du virus $virus dans la liste de la synthse\n";

	}

	# Creation du top 5 de la messagerie
	#
	# on dcoupe le nom sur le point, on garde la premiere partie et on stocke tout dans une table de hachage
	# tri par ordre dcroissant. Dans les cases du TOP 5 on met les 5 premiers virus du tableau tri
	my %top5virmail;

	# parcours l'ensemble des virus de la synthese
	$caseTB=3;
	my %lstmail; my $virus="init";
	while ($virus ne ""){
		$caseTB++;
		$virus = $F_S->Range(sprintf "N%d",$caseTB)->{'Text'};
		$lstmail{$virus} = $F_S->Range(sprintf "O%d",$caseTB)->{'Value'};
	}

	my $totalinfection = 0;
	# occurences sans variantes
	foreach $i (keys %lstmail){
		
		# on coupe le nom du virus au niveau du point
		my @virus = split(/\./,$i);

		# ainsi on regroupe tous les virus (et leurs occurences)
		# appartenant a la meme version majeure dans une seule table
		# de hachage
		$top5virmail{$virus[0]} += $lstmail{$i};
		$totalinfection += $lstmail{$i};
	}
	# classement dcroissant
	my @top5mail = sort{
			$top5virmail{$b}<=>$top5virmail{$a};
		}keys %top5virmail;

	$select = $F_S->Range("Q4:R4");
	$select->{Value} = [["Total mails inf","$totalinfection"]];
	my $cpt = 0;
	for $i(5..9){
		$select = $F_S->Range(sprintf "Q%d:R%d",$i,$i);
		$select->{Value} = [["$top5mail[$cpt]","$top5virmail{$top5mail[$cpt]}"]];
		$cpt++;
	}

	# Creation du top 5 des fichiers
	#
	# on dcoupe le nom sur le point, on garde la premiere partie et on stocke tout dans une table de hachage
	# tri par ordre dcroissant. Dans les cases du TOP 5 on met les 5 premiers virus du tableau tri
	my %top5virfich;

	# parcours l'ensemble des virus de la synthese
	$caseTB=3;
	my %lstfich; my $virus="init";
	while ($virus ne ""){
		$caseTB++;
		$virus = $F_S->Range(sprintf "T%d",$caseTB)->{'Text'};
		$lstfich{$virus} = $F_S->Range(sprintf "U%d",$caseTB)->{'Value'};
	}

	my $totalinfection = 0;

	# calcul du total
	foreach $i (keys %lstfich){
		$top5virfich{$i} += $lstfich{$i};
		$totalinfection += $lstfich{$i};
	}
	# classement dcroissant
	my @top5fich = sort{
			$top5virfich{$b}<=>$top5virfich{$a};
		}keys %top5virfich;

	$select = $F_S->Range("X4:Y4");
	$select->{Value} = [["Total mails inf","$totalinfection"]];
	my $cpt = 0;
	for $i(5..9){
		$select = $F_S->Range(sprintf "X%d:Y%d",$i,$i);
		$select->{Value} = [["$top5fich[$cpt]","$top5virfich{$top5fich[$cpt]}"]];
		$cpt++;
	}

	$fichierTB->Save;
	$fichierTB->Close;
	$fichiertemp->Close;
	$retour = 0;
	close DEBUG_EXPORT;
}
