#! /bin/perl
#####################################################################
#
#	Script de cration de deux fichiers :
#		*liste_virus_mail.txt
#		*liste_virus_fichiers.txt
#		
#	a partir des exploitation de logs antigen, WW et norton
#	pour intgration dans TBvirus
#
#	Version 0.1	-	Julien VEHENT	-	juillet 2006
#
#####################################################################


sub sub_listvirus() {

	local($DEBUG, $BOOLEEN_MAIL, $BOOLEEN_FICHIERS) = @_;

	# liste des fichiers
	$source_antigen = ".\\logs\\ANTIGEN_log_sortie.txt";
	$source_WW = ".\\logs\\WW_occurence_virus.txt";
	$source_norton = ".\\logs\\NORTON_detail.csv";
	$liste_mail = ".\\logs\\liste_virus_mail.csv";
	$liste_fichiers = ".\\logs\\liste_virus_fichiers.csv";
	$DEBUG_FILE = ".\\logs\\debug_TBvir.txt";

	if($BOOLEEN_MAIL==1){
		open (SRCWW,$source_WW) or die print "IMPOSSIBLE D'OUVRIR LE FICHIER  $source_WW\n$!\n";
		open (LISTMAIL,">$liste_mail") or die print "IMPOSSIBLE D'OUVRIR LE FICHIER  $liste_mail\n$!\n";
	}
	if($BOOLEEN_FICHIERS==1){
		open (SRCNORTON,$source_norton) or die print "IMPOSSIBLE D'OUVRIR LE FICHIER  $source_norton\n$!\n";
		open (LISTFICH,">$liste_fichiers") or die print "IMPOSSIBLE D'OUVRIR LE FICHIER  $liste_fichiers\n$!\n";
	}
	if($DEBUG==1){open (DEBUG_FILE, ">>$DEBUG_FILE") or die print "IMPOSSIBLE D'OUVRIR LE FICHIER  $DEBUG_FILE\n$!\n";}

	########################################
	# Creation de la liste des virus du mail
	#
	if($BOOLEEN_MAIL==1){
		my %lstmail;

		while(<SRCWW>){
			chomp;
			my($virus,$occurence)=split(/ : /,$_);
		
			#ajout de l'entre dans la table de hachage
			$lstmail{$virus} = $occurence;

			if($DEBUG==1){print DEBUG_FILE "SUB_LISTVIRUS ==> recherche du virus $virus dans les logs antigen\n";}

			#parcours des logs antigen a la recherche du meme virus
			open (SRCANTI,$source_antigen) or die print "IMPOSSIBLE D'OUVRIR $source_antigen  \n$!\n";

			while (<SRCANTI>){
				chomp;
				#le flag "i" permet d'etre insensible a la casse
				if($_ =~/$virus/i){
					#a chaque fois qu'on le trouve, on incrmente
					#l'occurence de ce virus
					$lstmail{$virus}++;
				}
			}
			close SRCANTI;
		}

		#
		# Ecriture dans le fichier en classement dcroissant
	
		#classement dcroissant ($b<=>$a)
		my @topmail = sort {
				$lstmail{$b}<=>$lstmail{$a}
			} keys %lstmail;
	
		#affichage
		my $totalmailsinf;
		for $i (0..$#topmail){
			
			print LISTMAIL "$topmail[$i];$lstmail{$topmail[$i]};---\n";
		}

		if($DEBUG==1){print DEBUG_FILE "SUB_LISTVIRUS ==> criture dans $liste_mail russie\n";}

		#####
		# TOP 5 
		my %top5virmail;

		# occurences sans variantes
		foreach $i (keys %lstmail){
			
			# on coupe le nom du virus au niveau du point
			my @virus = split(/\./,$i);

			# ainsi on regroupe tous les virus (et leurs occurences)
			# appartenant a la meme version majeure dans une seule table
			# de hachage
			$top5virmail{$virus[0]} += $lstmail{$i};
		}

		# classement dcroissant
		my @top5mail = sort{
				$top5virmail{$b}<=>$top5virmail{$a};
			}keys %top5virmail;

		# affichage prcd d'un dize
		print LISTMAIL "\n#;TOP 5 DES VIRUS DU MAIL\n";
		for $i(0..4){
			print LISTMAIL "#;$top5mail[$i];$top5virmail{$top5mail[$i]}\n";
		}
		if($DEBUG==1){print DEBUG_FILE "SUB_LISTVIRUS ==> criture du TOP 5 dans $liste_mail russie\n";}
	}


	########################################
	# Creation de la liste des virus norton
	#
	if($BOOLEEN_FICHIERS==1){
		my %lstfichiers;
		my %lsttypevir;

		while(<SRCNORTON>){

			# on ne considre pas les lignes qui commencent
			# par un dize
			unless ($_ =~/#/){
				chomp;
				@ligne_norton = split(/;/,$_);

				#la case 5 est le nom du virus, la 4 est le nb de fichiers inf
				#on a donc une entre par nom de virus et pour chacun d'eux le
				#nombre d'infections
				$lstfichiers{$ligne_norton[5]} += $ligne_norton[4];

				#on stocke galement le type de virus
				$lsttypevir{$ligne_norton[5]} = $ligne_norton[6] unless exists $lsttypevir{$ligne_norton[5]};
			}
		}
		close SRCNORTON;

		# classement dcroissant ($b<=>$a)
		@topfichiers = sort {
				$lstfichiers{$b}<=>$lstfichiers{$a}
			} keys %lstfichiers;
	
		# affichage
		for $i (0..$#topfichiers){
			print LISTFICH "$topfichiers[$i];$lstfichiers{$topfichiers[$i]};$lsttypevir{$topfichiers[$i]}\n";
		}
		if($DEBUG==1){print DEBUG_FILE "SUB_LISTVIRUS ==> criture dans $liste_fichiers russie\n";}
	}

	close LISTMAIL;
	close LISTFICH;
}
