#! /bin/perl
################################################################################
##
##	Script d'analyse des logs norton issus de SAV Reporter
##	
##
##	version 2	
##
##
##	Excution : perl via l'application TBvirus
## 
##	Julien VEHENT / DIT/ PSQ / Scurit
##
##	
################################################################################


sub sub_norton(){

	###########################################################
	# Rcupration du passage de paramtres
	#
	local($DEBUG,$debut_exploitation,$fin_exploitation) = @_;
	
	###########################################################
	# Ouverture des fichiers
	#
	#rpertoire contenant les logs
	my $rep_source = "\\\\XXXXXXXX\\secsi\\virus\\archivage\\Norton\\";
	#fichier de sortie
	my $fichsortie = ".\\logs\\result_fichiers.csv";
	#fichier de dtail
	my $detail = ".\\logs\\NORTON_detail.csv";
	#debug
	my $DEBUG_FILE = ".\\logs\\debug_TBvir.txt";

	#listage des fichiers de repsource dans un tableau
	opendir(REPNORTON,$rep_source) or die print "\nIMPOSSIBLE D'OUVRIR LE REPERTOIRE $rep_source\n$!\n";
	my @lstlogs = readdir(REPNORTON);
	close(REPNORTON);


	if($DEBUG==1){
		open (DEBUG_FILE, ">>$DEBUG_FILE") or die "SUB_NORTON ==> impossible d'ouvrir le fichier $DEBUG_FILE en ajout\n$!\n";
	}

	open (SORTVIR,">$fichsortie") or die "SUB_NORTON ==> impossible d'ouvrir le fichier $fichsortie en criture\n$!\n";
	
	open (DETAIL,">$detail") or die "SUB_NORTON ==> impossible d'ouvrir le fichier $detail en criture\n$!\n";
	print DETAIL "Nom du poste;Date;Utilisateur;Fichier;#NB fichiers inf;Virus;Type virus;Action1;Action2;IP du poste;Serveur parent;Logger;\n";


	foreach $fichier (@lstlogs){

		if($DEBUG==1){print DEBUG_FILE "SUB_NORTON ==> lecture du fichier $fichier\n";}

		#rcupration de la date de gnration au format AAAAMMJJ
		my $datedebfichier = substr($fichier,12,8);
		my $datefinfichier = substr($fichier,23,8);

		#comparaison des dates
		if(	$datefinfichier < $debut_exploitation 	# si la date de fin du fichier est avant la priode exploite
			or					# ou
			$datedebfichier > $fin_exploitation	# si la date de dbut du fichier est aprs la priode exploite
		){if($DEBUG==1){print DEBUG_FILE "SUB_NORTON ==> le fichier $fichier n'est pas considr\n";} # on ne le traite pas
		}

		# sinon exploitation du contenu du fichier
		else{
			open (LOGNORTON,$rep_source.$fichier) or die print "SUB_NORTON ==> impossible d'ouvrir $rep_source.$fichier\n$!\n";
			if($DEBUG==1){print DEBUG_FILE "SUB_NORTON ==> entre dans $fichier\n";}
			#la premiere ligne est l'entete
			my $DROP = <LOGNORTON>;

			#################################					
			#
			# rcupration des champs exploitables dans le fichier de logs
			#
			# on obtient une table de hachage dont les cls sont les numros d'id et dont les
			# valeurs sont des rfrences vers des tableaux de champs
			#
			#  %table		@{$table{$id}}
			# +------+		+--0---+--1---+--2---+------+------+------+
			# |      |		|      |      |      |      |      |      |
			# | 318 ------------>	| date | nom  | type | ...................|
			# |	 |		|      |      |      |                    |
			# |	 |		+------+------+------+------+------+------+
			# +------+		+--0---+--1---+--2---+------+------+------+
			# |      |		|      |      |      |      |      |      |
			# | 320 ------------>	| date | nom  | type | ...................|
			# |	 |		|      |      |      |                    |
			# |	 |		+------+------+------+------+------+------+
			# +------+		+--0---+--1---+--2---+------+------+------+
			# |      |		|      |      |      |      |      |      |
			# | 321 ------------>	| date | nom  | type | ...................|
			# |	 |		|      |      |      |                    |
			# +------+		+------+------+------+------+------+------+
			# | ...	 |		+------+------+------+------+------+------+
			#
			# pour l'affichage, il faut utiliser :
			# foreach $id (keys %table){print "$id => @{$table{$id}}\n";}
			#
			# pour accder  une valeur spcifique, on utilise la syntaxe :
			# ${$table{$id}}[0] ceci affiche la valeur 0 (correspond ici  $date)
			#

			while (<LOGNORTON>){
				chomp;
				#on dcoupe la ligne dans des scalaires (giveup = on garde pas)
				my (	$id, $date, $DROP1, $DROP2, $logger, $nb_infections, 
					$DROP4, $nom_virus, $type_virus, $fichier_inf, $DROP5, 
					$action1, $action2, $DROP6, $DROP7, $srv_parent, $nom_ordi, 
					$ip_ordi, $utilisateur, $DROP10, $DROP11, $DROP12, $DROP13, 
					$DROP14, $DROP15, $DROP16) = split(/;/,$_);

				#remplissage du tableau 

				push @{$donnees_brutes{$id}}, $date, $nom_virus, $nb_infections, $type_virus, $fichier_inf, $action1
							, $action2, $nom_ordi, $ip_ordi, $logger, $utilisateur, $srv_parent;
			}
			close LOGNORTON;
		}
	}

	################################
	#
	# Selection sur la date
	#
	my %resultat;
	foreach $id (sort keys %donnees_brutes){

		# on rcupre la date d'une ligne, on la compare par rapport a la priode exploite
		# et si elle ne rentre pas dedans, on supprime la ligne
		my ($dateligne, $heureligne) = split(/ /,${$donnees_brutes{$id}}[0]);
		$dateligne =~ s/-//g;

		if( 	$dateligne < $debut_exploitation
			or
			$dateligne > $fin_exploitation
		){
		if($DEBUG==1){print DEBUG_FILE "SUB_NORTON ==> la date $dateligne n'est pas considre\n";}
			#suppression de la ligne
			delete( $donnees_brutes{$id} ) or die print "SUPPRESSION IMPOSSIBLE\n";
		}
		# sinon : exploitation de la ligne
		else {
			#on ne conserve que la date JJMMAAA, pas l'heure car un fichier peut etre
			#dtect plusieurs fois a des heures diffrentes alors que c'est le meme
			#virus sur le meme fichier
			${$donnees_brutes{$id}}[0] = $dateligne;

			################################
			#
			# Nettoyage des doublons
			#
			# chaque ligne de la table resultat est une infection detectee
			#
			# il est important de parcours la table %donnees_brutes dans l'ordre
			# donc on utilise un 'sort'
			#
			my @donnees = @{$donnees_brutes{$id}};

			#suppression des doublons
			if (1 == comp_tableau(\@donnees, \@old_donnees)){
	
				#inscription de la suppression dans le fichier DEBUG
				if($DEBUG==1){print DEBUG_FILE "SUB_NORTON ==> suppression de la ligne $id qui est",
					" un doublon de la ligne $old_id\n";
						$cpt_doublon +=1;}
			} 
			else {	
				#ecriture de la ligne dans une table de hachage pour comptage ulterieur
				$resultat{$id} = [] unless exists $resultat{$id};
				push @{$resultat{$id}}, @donnees;

				#les doublons se suivent toujours, donc on garde la valeur teste
				#pour l'inspection suivante
				@old_donnees = @donnees;
				$old_id = $id;
			}
		}
	}

	################################
	#
	# Exploitation des rsultats
	#
	#
			
	# init des totaux de sortie 
	foreach $id (keys %resultat){my $date = ${$resultat{$id}}[0]; for $i (0..4){	${$sortie{$date}}[$i] = 0; } }
	
	# parcours de la liste des resultats
	foreach $id (sort keys %resultat){

		#on ne prend pas les lignes de type Defwatch (analyse reporte)
		unless (${$resultat{$id}}[9]=~/Defwatch/) {

			#################
			# type de l'ordinateur infects
			my ($ord_agence, $ord_siege, $serveur)=0;

			# on dcoupe les octets de l'ip pour analyse (proteger le point avec un antislash)
			my ( $ip_octet_1, $ip_octet_2, $ip_octet_3, $ip_octet_4) = split(/\./,${$resultat{$id}}[8]);

			# plage d'adresse hors siege, c'est un peu tout et n'importe quoi
			if ( ($ip_octet_2 != 230) and ($ip_octet_2 != 231) ){
				$ord_agence=1;
			}
			else{	# d'aprs JF Piat, les serveurs sont sur 2 VLAN : 10.231.223.0/24 et 10.231.240.0 /22
				if (($ip_octet_2 == 231) and (($ip_octet_3 == 223) or ($ip_octet_3 == 240))){
					$serveur=1;
				}
				else{	# on considre que toute autre adresse est un poste client au sige					
					$ord_siege=1;
				}
			}
			##################
				
			my $date = ${$resultat{$id}}[0];

			# si une entre existe dj pour cette date, perl ajoutera nos valeurs
			# dans les champs existants
			# sinon une nouvelle entre sera cre automatiquement
			${$sortie{$date}}[0] += ${$resultat{$id}}[2];
			${$sortie{$date}}[1]++;
			${$sortie{$date}}[2] += $ord_agence;
			${$sortie{$date}}[3] += $ord_siege;
			${$sortie{$date}}[4] += $serveur;

			#on met la ligne courante dans le fichier DETAIL
			for $i (7,0,10,4,2,1,3,5,6,8,11,9){
				print DETAIL "${$resultat{$id}}[$i];"
			}
			print DETAIL "\n";
			#comptage des postes infects unique
			$postes_uniq{${$resultat{$id}}[7]} = 1;

		}
		else { if($DEBUG==1){print DEBUG_FILE "SUB_NORTON ==> ligne Defwatch ignore : id=$id\n";
					$cpt_defwatch++;}}
	}

	#####
	#criture des rsultats
	
	# infections par date
	foreach $date (sort keys %sortie){

		# on n'imprime que les entre ayant des valeurs non nulles
		unless(${$sortie{$date}}[0]==0){
			print SORTVIR substr($date,6,2)."/".substr($date,4,2)."/".substr($date,0,4),";${$sortie{$date}}[0];${$sortie{$date}}[1];",
				"${$sortie{$date}}[2];${$sortie{$date}}[3];${$sortie{$date}}[4];\n";
		}
	}
	close SORTVIR;

	# nombre de postes dans le fichier de dtail
	my $cpt_post_uniq = 0;
	print DETAIL "#\n#\n#;LISTE DES POSTES INFECTES :\n";
	foreach $ord (keys %postes_uniq){
		print DETAIL "#;$ord\n";
		$cpt_post_uniq++;
	}
	print DETAIL "#;soit => $cpt_post_uniq postes\n";
	close DETAIL;

	# nombre de doublon et de lignes defwatch dans le fichier DEBUG
	if($DEBUG==1){	print DEBUG_FILE "SUB_NORTON ==> ###  $cpt_doublon doublons ont t trouvs\n";
			print DEBUG_FILE "SUB_NORTON ==> ###  $cpt_defwatch lignes Defwatch ont t trouvs\n";
			print DEBUG_FILE "SUB_NORTON ==> ### Purges des tables de donnes :\n";
			close DEBUG_FILE;}

	# purge des table de hachage 
	foreach $k (keys %postes_uniq){ delete $postes_uniq{$k}; }
	foreach $k (keys %donnees_brutes){ delete $donnees_brutes{$k}; }
	foreach $k (keys %sortie){ delete $sortie{$k}; }
}



#################################
#
# Comparaison de deux tableaux (ref 21.5.5 guide perl, p244)
#
# => si les deux tableaux sont diffrents, la fonction renvoie la valeur 0
# => sinon, elle renvoie 1 a la fin de la fonction

sub comp_tableau(){
	my($actuel, $ancien) = @_;
	no warnings;

	#comparaison des references aux tableaux
	return 0 unless @$actuel == @$ancien;

	#comparaison des valeurs 
	for (my $i = 0; $i < @$actuel; $i++){
		return 0 if $actuel->[$i] ne $ancien->[$i];
	}

	#on a test references et valeurs sans quitter, les tableaux
	#sont identiques donc on retourne 1									#
	return 1;												#
}														#
										#################################
