#! /bin/perl
#####################################################################
#
#	Script de cration d'un fichier resultat_mail.txt
#	a partir des exploitation de logs antigen et WW
#	pour intgration dans TBvirus
#
#	Version 0.1	-	Julien VEHENT	-	juillet 2006
#
#####################################################################


sub sub_result_mail() {

	local($DEBUG,$debut_exploitation,$fin_exploitation) = @_;

	# liste des fichiers
	$result_antigen = ".\\logs\\ANTIGEN_log_date.txt";
	$result_WW = ".\\logs\\WW_comptage_journalier_virus.txt";
	$report = "\\\\XXXXXXXXX\\secsi\\Virus\\Archivage\\Report\\";
	$result_MAIL = ".\\logs\\result_mail.csv";
	$DEBUG_FILE = ".\\logs\\debug_TBvir.txt";

	# lecture du dossier contenant les totaux journaliers pour les mails entrants / sortants
	opendir(DIRREPORT, $report) or die print "IMPOSSIBLE D'OUVRIR LE DOSSIER $report\n$!";
	@lstreport = readdir(DIRREPORT)or die print "IMPOSSIBLE DE LIRE LE CONTENU DU DOSSIER $report\n$!";
	close DIRREPORT;

	if($DEBUG==1){
		open (DEBUG_FILE, ">>$DEBUG_FILE") or die print "IMPOSSIBLE D'OUVRIR LE FICHIER $DEBUG_FILE\n$!\n";
		print DEBUG_FILE "SUB_RESULT_MAIL ==> lecture du rpertoire $report russi\n"; 
	}

	# ouverture du fichier de rsultat
	open(RESULT,">$result_MAIL") or die print "IMPOSSIBLE D'OUVRIR $result_MAIL\n$!\n";

	# traitement de la priode exploite
	my %mois = ("Jan"=>"01", "Feb"=>"02", "Mar"=>"03", "Apr"=>"04", "May"=>"05", "Jun"=>"06", 
		"Jul"=>"07", "Aug"=>"08", "Sep"=>"09", "Oct"=>"10", "Nov"=>"11", "Dec"=>"12");

	#ce format est utilis pour le test sur les noms des fichiers
	my $dtdeb = substr($debut_exploitation,4,2).substr($debut_exploitation,0,4);
	my $dtfin = substr($fin_exploitation,4,2).substr($fin_exploitation,0,4);

	#hachage pour le calcul des totaux
	my %totaux;
	$totaux{'entrants'} = 0;
	$totaux{'sortants'} = 0;
	$totaux{'webwasher'}= 0;
	$totaux{'antigen'}  = 0;

	# parcours de la liste des fichiers de rapport pour les mails entrants / sortants
	foreach $reportfile (@lstreport){

		if($DEBUG==1){print DEBUG_FILE "SUB_RESULT_MAIL ==> test de date sur le fichier $reportfile\n";}

		# conversion de la date du fichier au format MMAAAA
		my $datefichier = substr($reportfile,12,7);

		#remplacement des lettres par des chiffres pour le mois
		foreach $i (keys %mois){
			$datefichier =~s/$i/$mois{$i}/;
		}

		# est-ce que le fichier est dans la priode de temps considre ?
		if(	$datefichier < $dtdeb
			or
			$datefichier > $dtfin
		){if($DEBUG==1){print DEBUG_FILE "SUB_RESULT_MAIL ==> le fichier $reportfile est hors limites\n";}
		}
		else{
			# ouverture du fichier
			open(REPORT, $report.$reportfile) or die print "IMPOSSIBLE D'OUVRIR $reportfile\n$!\n";
	
			#on saute les deux premires lignes
			my $drop = <REPORT>;
			my $drop = <REPORT>;

			#parcours des lignes du fichier de comptage des mails
			while(<REPORT>){

				# remplace des sries d'espaces par un seul
				$_ =~ s/\s+/ /g;
		
				#dcoupe les champs sur le critre de l'espace
				my @ligne_report = split(/ /,$_);

				#remplacement des lettres par des chiffres pour le mois
				foreach $i (keys %mois){
					if($ligne_report[0] =~ /$i/){
						$ligne_report[0] =~ s/$i/$mois{$i}/;
					}
				}
				my $dateligne = substr($ligne_report[0],6,4).substr($ligne_report[0],3,2).substr($ligne_report[0],0,2);

				if(	$dateligne < $debut_exploitation
					or
					$dateligne > $fin_exploitation
				){if($DEBUG==1){print DEBUG_FILE "SUB_RESULT_MAIL ==> l'entre du $ligne_report[0] est hors limite\n";}
				}
				else{	# fonction de parcours du fichier antigen
					my $retour_antigen = parcours_antigen($ligne_report[0]);
					
					# fonction de parcours du fichier webwasher
					my $retour_webwasher = parcours_webwasher($ligne_report[0]);
					
					#on cris tout cela dans le fichier de rsultat
					print RESULT "$ligne_report[0];$ligne_report[1];$ligne_report[2];",
						"$retour_webwasher;$retour_antigen;\n";
					if($DEBUG==1){print DEBUG_FILE "SUB_RESULT_MAIL ==> ligne pour $ligne_report[0] crite avec succs\n";}
					#sommes pour totaux
					$totaux{'entrants'} += $ligne_report[1];
					$totaux{'sortants'} += $ligne_report[2];
					$totaux{'webwasher'} += $retour_webwasher;
					$totaux{'antigen'} += $retour_antigen;
				}
				
			}
			close REPORT;
		}
	}	
	####
	# Impression des totaux
	#
	print RESULT 	"################################################################\n",
			"# Mails_entrants\t\t$totaux{'entrants'}\n",
			"# Mails_sortants\t\t$totaux{'sortants'}\n",
			"# WebWasher\t\t$totaux{'webwasher'}\n",
			"# Antigen\t\t\t$totaux{'antigen'}\n";
	close RESULT;
}

####
# Fonction de recherche dans les resultat antigen
#
# on va rechercher l'entree correspondant a la date 
# passee en parametre
#
# si l'entree n'existe pas, la fonction renvoie la
# valeur "0"
# sinon, elle renvoie la valeur du nombre de virus
#

sub parcours_antigen(){

	@date_recherchee = @_;

	if($DEBUG==1){print DEBUG_FILE "SUB_RESULT_MAIL ==> entree dans la fonction parcours_antigen : recherche de $date_recherchee[0]\n";}

	open(R_ANTI,$result_antigen) or die print "IMPOSSIBLE D'OUVRIR $result_antigen\n$!\n";
	while(<R_ANTI>){
		my @ligne_antigen = split(/ /,$_);
			
		#si les dates correspondent
		if ($date_recherchee[0] eq $ligne_antigen[0]){

			if($DEBUG==1){print DEBUG_FILE "SUB_RESULT_MAIL ==> entree trouve, valeur antigen : $ligne_antigen[2]\n";}

			#on sors de la fonction en renvoyant le nombre
			#de virus pour cette date
			close R_ANTI;
			return $ligne_antigen[2];
		}
	}
	#si la valeur n'a pas t trouve, on sors 
	#en renvoyant la valeur 0
	close R_ANTI;
	return 0;
}

####
# Idem que parcours_antigen mais pour webwasher
#
sub parcours_webwasher(){
	$date_recherchee = @_;

	if($DEBUG==1){print DEBUG_FILE "SUB_RESULT_MAIL ==> entree dans la fonction parcours_webwasher : recherche de $date_recherchee[0]\n";}

	open(R_WW,$result_WW) or die print "IMPOSSIBLE D'OUVRIR $result_WW\n$!\n";
	while(<R_WW>){
		my @ligne_WW = split(/ /,$_);
		if($date_recherchee[0] eq $ligne_WW[0]){

			if($DEBUG==1){print DEBUG_FILE "SUB_RESULT_MAIL ==> entree trouve, valeur WW : $ligne_WW[2]\n";}

			close R_WW;
			return $ligne_WW[2];
		}
	}
	close R_WW;
	return 0;
}
