################################################################################
##
##	Script d'analyse Mc Afee / WebWasher pour intgratio dans TBvirus
##
##	Julien VEHENT - juillet 2006
##		
##		->r-criture du script de C. MOREAU
##
################################################################################


#!/bin/perl
sub sub_webwasher() {

	local($DEBUG,$debut_exploitation,$fin_exploitation) = @_;

	#rpertoire de stockage des logs
	$dir_logs_WW = "\\\\XXXXXXXX\\secsi\\virus\\archivage\\Webwasher\\";

	#listage des fichiers dans un tableau
	opendir(LOGWW,$dir_logs_WW) or die print "\nIMPOSSIBLE D'OUVRIR LE REPERTOIRE $dir_logs_WW";
	@lst_logs = readdir(LOGWW);
	close(LOGWW);

	#fichiers de sortie
	my $DEBUG_WW = ".\\logs\\debug_TBvir.txt";
	my $occ_vir = ".\\logs\\WW_occurence_virus.txt";
	my $cpt_vir = ".\\logs\\WW_comptage_journalier_virus.txt";

	open (OCCVIR, ">$occ_vir") or die print "\nIMPOSSIBLE D'OUVRIR LE FICHIER $occ_vir EN ECRITURE";
	open (CPTVIR, ">$cpt_vir") or die print "\nIMPOSSIBLE D'OUVRIR LE FICHIER $cpt_vir EN ECRITURE";
	if($DEBUG==1){
		open (DEBUG_WW, ">>$DEBUG_WW") or die print "IMPOSSIBLE D'OUVRIR LE FICHIER DEBUG EN ECRITURE\n$!";
	}

	# modification du format des dates
	$datedeb = substr($debut_exploitation,2,6);
	$datefin = substr($fin_exploitation,2,6);
	if($DEBUG==1){print DEBUG_WW "SUB_WEBWASHER ==> exploitation pour la periode du $datedeb au $datefin\n";}


	#table de hachage pour les occurences de virus
	my %occ_virus;
	my %occ_virus_sans_variantes;
	my %comptage_mails_recus;

	#parcours des fichiers
	foreach $fichier (@lst_logs){
		
		#controle de date
		my $datefichier = substr($fichier,12,6);

		if($DEBUG==1){print DEBUG_WW "SUB_WEBWASHER ==> date testee : $datefichier, fichier : $fichier\n";}

		# correction de la date du fichier qui est gnr le lendemain du jour exploit
		$datefichier = correction_date($datefichier);
		if($DEBUG==1){print DEBUG_WW "SUB_WEBWASHER ==> date modifie ==> $datefichier\n";}
	
		#comparaison de dates
		if (	($datefichier < $datedeb)
			or 
			($datefichier > $datefin)
		){ if($DEBUG==1){print DEBUG_WW "SUB_WEBWASHER ==> le fichier $fichier est hors limite de date\n";}
		}
		else {
			#ouverture du fichier de logs
			open(FICHLOG,$dir_logs_WW.$fichier) or die print"\nIMPOSSIBLE D'OUVRIR LE FICHIER $fichier EN LECTURE";

			#parcours des lignes du fichier
			while(<FICHLOG>){
				
				##
				#rcupration et mise en forme du nom du virus
				my @champs = split(/ /,$_);
				my $nom_virus = $champs[3];
				$nom_virus = substr($nom_virus, 0, length($nom_virus)-1);
				
				##
				#incrmente le total d'infection pour ce virus
				$occ_virus{$nom_virus}++ ;

				##
				#incrmente le total d'infection pour ce TYPE de virus
				#
				#remise en forme du nom du virus sans le suffixe
				@variante = split(/\./,$nom_virus);
				$nom_virus = $variante[0];
				#ajout dans la deuxime table de hachage 
				$occ_virus_sans_variantes{$nom_virus}++ ;

				##
				#incrmente le total de mails vrols recus pour cette date
				$comptage_mails_recus{$datefichier}++;

			}
			close(FICHLOG);

		}
	}
	##
	# Impression des rsultats
	#
	#1.comptage journalier
	my $total = 0;
	foreach my $date (sort keys %comptage_mails_recus){
		
		# mise en forme de la date au format JJ/MM/AAAA
		my $jour = substr($date,-2,2);
		my $mois = substr($date,-4,2);
		my $annee = substr($date,-5,1);
		my $date_formated = $jour."/".$mois."/"."200".$annee;

		# ajout de la valeur au total
		$total += $comptage_mails_recus{$date};
		print CPTVIR "$date_formated : $comptage_mails_recus{$date} mails infectes.\n";
	}
	if($DEBUG==1){print DEBUG_WW "SUB_WEBWASHER ==> criture dans $cpt_vir russie\n";}

	print CPTVIR "\n\nTOTAL : $total";

	#
	#2.occurence par virus 
	foreach my $i (sort keys %occ_virus){
		print OCCVIR "$i : $occ_virus{$i}\n";
	}
	if($DEBUG==1){print DEBUG_WW "SUB_WEBWASHER ==> criture dans $occ_vir russie\n";}

	close(OCCVIR);
	close(CPTVIR);

	if($DEBUG==1){
		close DEBUG_WW;
	}
}

#					FIN DU SCRIPT PRINCIPAL									#
#################################################################################################################################












####
# Correction_date : manipulation de la date des fichiers de logs
#
# Les fichiers de log webwasher sont gnr le lendemain pour la journe en cours.
# Donc il faut grer la correction de la date, ce qui inclus un certain nombre de
# cas particulier :
# 	* si le fichier est dat du premier jour d'un mois ,on le date du dernier 
# 	jour du mois prcdent :
# 		=> distinction des mois a 30 jours, 31 jours et de fvrier dans les
# 		annes bisextiles ou non (prvu jusqu'en 2019)
#	* si le fichier est dat du 1er janvier, on le date du 31 dcembre de 
#	l'anne prcdente
# 			
# Mais si le fichier n'est pas dat au premier jour d'un mois, on dcrmente 
# simplement sa valeur de jour
#
sub correction_date(){
	
	#on stocke TOUJOURS les parametres dans un tableau
	my @datefichier = @_;

	#si c'est le premier jour du mois
	if (01 == substr($datefichier[0],4,2)){
		if($DEBUG==1){print DEBUG_WW "SUB_WEBWASHER ==> gestion d'un cas de dbut de mois pour $datefichier[0]\n";}
		
		my $mois = substr($datefichier[0],2,2);

		#gestion des mois a 30 jours
		if(05==$mois or 07==$mois or 10==$mois or 12==$mois){
			if(12==$mois){
			$datefichier[0] = substr($datefichier[0],0,2).($mois-1)."30";
			}
			else{
			$datefichier[0] = substr($datefichier[0],0,2)."0".($mois-1)."30";
			}
		}
		else { 
			#gestion des mois a 31 jours
			if(2==$mois or 4==$mois or 6==$mois or 8==$mois or 9==$mois or 11==$mois){
				if(11==$mois){
					$datefichier[0] = substr($datefichier[0],0,2).($mois-1)."31";
				}
				else{	$datefichier[0] = substr($datefichier[0],0,2)."0".($mois-1)."31";}
			}
				#gestion de fevrier
			else {	if (03 == $mois){
					#annee bisextile
					my $annee = substr($datefichier[0],0,2);
					if (8==$annee or 12==$annee or 16==$annee){
						$datefichier[0] = substr($datefichier[0],0,2)."0229";
					}
					else{
						$datefichier[0] = substr($datefichier[0],0,2)."0228";
					}
				}
				else {	#gestion du cas particulier du 1er janvier
					if(01 == $mois){
						$datefichier[0] = (substr($datefichier[0],0,2)-1)."1231";
					}
				}
			}
		}
		if($DEBUG==1){print DEBUG_WW "SUB_WEBWASHER ==> datefichier est maintenant : $datefichier[0]\n";}
	}
	# enfin, on traite le cas d'un jour normal (ouf !)
	else {	$datefichier[0] -= 1 ;
	}
	
	return $datefichier[0];
}
